#daw_linknavi_n_setting.cgi
#設定および共通library

########################################################################
#スクリプト制作 DIGITAL@WORKS(http://www1.ocn.ne.jp/~daworks/)
#COPYRIGHT DIGITAL@WORKS ALL RESERVED
#許可なく複製・改変・再配布等を禁止します
########################################################################

#=======================================================================
#全体の設定と共通処理のプロシージャ
#=======================================================================

######################################################
#基本設定

#表示ページの文字コード
$enc  = 'utf8'; #('utf8','euc','jis','sjis')
%enc = ('jis'  => 'ISO-2022-JP','sjis' => 'Shift_JIS','euc'  => 'EUC-JP','utf8' => 'UTF-8');

#設置するサーバーのドメイン(最後の「/」は省く)
$domain = "http://abc.com";

#マスターパスワード(トラブル防止のため半角英数をオススメします)
$masterpass = "abcdef";
#==========================================================================================
#マスターパスワードを使用すると、管理人権限として以下のことが可能です
#サイト名の文字数制限がなくなります
#@nourlで禁止したアドレスでも登録できます
#相互リンク必須の場合もリンク先無しで登録できます
#メールアドレスが必須の場合でも入力無しで登録できます
#サイト紹介文が必須の場合の紹介文無し、もしくは禁止文字が入っている場合でも登録できます
#コード認証の必要がありません
#連続投稿が禁止されている場合も連続投稿が可能です
#アフィリエイトの登録が可能です(有償版のみ)
#削除・修正が自由に行えます
#==========================================================================================

#トップページのURL
$tophtml = "$domain"."/";

#cgiの設置ディレクトリ名
$cgidir ="cgi-bin";

#画像ディレクトリ名
$imgdir = "img";

#出力するHTMLからこのScriptへの相対パス
$dir1 = ".."; #同一階層なら"."

#このScriptから他のScriptへの相対パス
$dir2 = ".";

#ロック処理の設定 lockディレクトリを作成(Scriptと同一階層)
$lockdir = "lock/lock";

#CGIスクリプト名(デフォルトから変更する場合は書き換えてください)
$settingcgi = "daw_linknavi_n_setting.cgi"; #このスクリプト名です
#==========================================================================================
#※本スクリプト名を変更した場合、すべてのスクリプトの12行目にある
#「require'./daw_linknavi_n_setting.cgi';」を変更したスクリプト名に書き換える必要があります
#==========================================================================================
$entrycgi = "daw_linknavi_n_newentry.cgi"; #登録用Script
$buildcgi = "daw_linknavi_n_build.cgi"; #ページ作成用Script
$admincgi = "daw_linknavi_n_admin.cgi"; #管理用Script
$outcountcgi ="daw_linknavi_n_outcount.cgi"; #アウトカウント用Script

#グリニッジ標準時との誤差修正 +9時間
$plusgmt = "32400";

#このScriptで作成するHTML
$makehtml = "index.html";

#カテゴリーの名称(追加する場合、「,」で区切って「""」で括る)
@cidname = ("コンピュータ","マネー・ビジネス","ニュース・政治","健康とスポーツ","教育と文化","娯楽と趣味","コミュニケーション","飲食・グルメ","美容とファッション","芸\能\・映画・音楽","結婚と育児","ショッピング","ホームページ作成","便利情報","その他");

#すべてのカテゴリーの名称
$allgenre = "All Genre";

#すべてのカテゴリーのID
$allid = "99";

#カテゴリー名の表示に画像を使用するか 1=使用する
$genreimgsw = 0;

#$genreimgsw = 1の場合、すべてのカテゴリーに使用する画像ファイル(ファイルは$imgdirの画像ディレクトリに置きます)
$allgenreimg = "";

#$genreimgsw = 1の場合、カテゴリーに使用する画像ファイル(@cidnameと対になるように ファイルは$imgdirの画像ディレクトリに置きます)
@cidimg = ();

#$genreimgsw = 1の場合の画像サイズ
$genreimgw = 88; #幅
$genreimgh = 31; #高さ

#すべてのカテゴリーを選択した際にアダルトなど表示させたくないカテゴリーが存在する場合、そのカテゴリー名を記述すると表示されません(@cidnameの中からカテゴリー名を記述)
#※カテゴリメニューの中からそのカテゴリーを選択した場合は表示されます。カテゴリー選択でも表示させたくない場合は下の@nojumplistと併用してください
@noall = (""); #""で囲んで,で区切る 登録後の追加、変更可

#カテゴリーメニューから直接表示させたくないカテゴリーを記述すると指定したぺージを表示します。アダルトなど警告ページを表示させたい場合などに使用します(@cidnameの中からカテゴリー名を記述)
@nojumplist = (""); #""で囲んで,で区切る
#※別ページからカテゴリーを表示させる場合は、以下のようなリンクを作成してください(「」内は書き換えること)。
#「daw_linknavi_p(n)_build.cgiまでフルパス」?getid=「表示させたいカテゴリーID @cidnameの先頭を0として対象となるカテゴリーの番号を記述」&viewtype=1&ranktype=0&imgtype=1&page=1

#@nojumplistで指定したカテゴリーの表示させるHTMLを記述します(@nojumplistと対になるように記述してください)
@nojumphtml = ("index.html"); #""で囲んで,で区切る

#新規登録および削除・修正時にTOPページのHTMLを自動で更新するか 1=更新する
$autoupdate_entry = 1;

#ページのリロード時にTOPページのHTMLを自動で更新するか 1=更新する(更新しない場合は管理画面で更新するまでランキングが反映されません)
$autoupdate_reload = 1;

#サムネイルを有効にした場合、使用する外部サイトURL($onlinethum+対象サイトURLでサムネイルが表示できる形で記述)
#$onlinethum = "http://mozshot.nemui.org/shot?"; #Mozshot 128x128
$onlinethum = "http://img.simpleapi.net/small/"; #SimpleAPI 128x128

#サムネイルの幅を使用する外部サイトに合わせて指定
$thumwidth = "128";
#==========================================================================================
#サイトのサムネイル表示は外部サイトを利用します
#これらのサイトに仕様変更・閉鎖があった場合は利用できなくなる可能性があることをご了承ください
#==========================================================================================

######################################################
#スキンの設定

#SKINディレトリ名($cgidirディレクトリ内に置く場合は「$cgidir/skin」のように記述)
$skindir = "skin";

#ベーススキンHTML($skindir/から記述)
$baseskinhtml="$skindir/Skin_Sample_01.html";

######################################################
#サイト登録の設定

#管理人のみ登録可能(ログイン画面を表示してマスターパスの入力を必要にする) 1=有効
$adminonly = 0;

#登録されたサイトの表示に管理人の承認が必要か 1=必要
$adminshow = 0;

#重複するサイト名の登録を許可するか 1=許可する
$samesitename = 0;

#登録に相互リンクを必要とするか 0=不要 1=任意(ランクで優先) 2=必須
$sogo = 1;

#$sogo = 0の説明文(タグ使用可 本文中に「"」を使用する場合は\でエスケープしてください)
$sogomsg0 = "相互リンクは任意です。特に特典はありませんので、相互リンクしていただくかはお任せします。<br>※同じサイト名、同一URLの複数登録は禁止です。<br>※登録されたサイトは管理人の判断でカテゴリー変更や削除をさせていただく場合があります。<br><br>";

#$sogo = 1の説明文(タグ使用可 本文中に「"」を使用する場合は\でエスケープしてください)
$sogomsg1 = "相互リンクは任意ですがランキングで優先されます。<br>相互リンクは先に登録されるサイトに\$toppageへのリンクを張ってください。<br>※同じサイト名、同一URLの複数登録は禁止です。<br>※登録されたサイトは管理人の判断でカテゴリー変更や削除をさせていただく場合があります。<br><br>";

#$sogo = 2の説明文(タグ使用可 本文中に「"」を使用する場合は\でエスケープしてください)
$sogomsg2 = "登録には相互リンクが必要です。<br>まずは登録されるサイトに$tophtmlへのリンクを張ってください。<br>※同じサイト名、同一URLの複数登録は禁止です。<br>※登録されたサイトは管理人の判断でカテゴリー変更や削除をさせていただく場合があります。<br><br>";

#sogomsg以下の共通する説明(必要に応じてEOS～EOSの間を書き換えてください。タグ使用可 エスケープは必要なし)
$subentrymsg =<<EOS;
<p class="txt_red txt_bold">このリンク集に登録できるのは一般サイトのみです。<br>アダルトサイトを発見した場合はただちに削除します。</p><br>
<p class="txt_center">---------------------------------------------------------<p><br>リンク設置後、以下のフォームからご登録ください。
EOS

#サイト名の最大文字数
$maxsitename = 20;

#URLの禁止サイト(以下の文字が含まれる場合は登録禁止)
@nourl = (); #""で囲んで,で区切る

#登録したリンク先が存在するか自動でチェックする 1=有効(有効にすると若干時間がかかるため、エラーがない場合のみ実行します)
#この機能を有効にするとSSLやTLSで暗号化されたサイト(httpsで始まるサイト等)の登録ができなくなりますので注意してください
$htmlautoch = 1;

#相互リンクのページが存在し、相互リンクが張られているかを自動でチェックする 1=有効(有効にすると若干時間がかかるため、エラーがない場合のみ実行します)
#この機能を有効にするとSSLやTLSで暗号化されたサイト(httpsで始まるサイト等)の登録ができなくなりますので注意してください
$sogoautoch = 1;

#メールアドレスの登録を必要とするか 0=不要(フォームを表示しない) 1=任意 2=必須
$mailch = 1;

#登録を拒否するメールアドレス(以下の文字が含まれるメールアドレスは登録禁止)
@nomailch = (); #""で囲んで,で区切る

#サイト紹介文の入力を必須とするか 0=任意 1=必須
$sitemsgch = 0;

#サイト紹介文の最大文字数
$maxmsg = 150;

#サイト紹介文禁止文字(以下の文字が含まれる場合は登録禁止)
@nositetxt = ("<",">","&lt","&gt","aaa","あああ");

#紹介文の代わりにmeta name="description" contentの内容を習得する機能を表示するか 1=有効(フォームを表示) 紹介文が入力されていると紹介文が優先されます
$metacon = 1;

#削除・変更パスワードの文字数(バイト)
$passmin = 6; #以上
$passmax = 10; #以内

#スパム防止用にコード認証を必要とするか 0=必要としない 1=数値入力方式 2=質問回答方式
$codesw = 1;

#$codesw=2の場合の質問内容(曖昧な回答になる質問は避けてください)
$codetxt = "６＋４の解答を半角の英語で入力してください。";

#$codetxtの質問に対する正解
$codepass = "ten";

#新規登録時に確認画面を表示する 1=表示する
$checkentry = 1;

#新規登録時にデータベースを自動でリフレッシュするか 1=有効
$entry_autorefresh = 0;

#データベースに同名のサイトがある場合のエラーメッセージ(タグ使用可「"」を使用する場合は\でエスケープしてください)
$sitenameerrmsg = "同名のサイトが既に登録されています。<br>古い登録を修正・削除するか(登録者の場合)サイト名を変更して登録してください。";

#データベースに同じURLが登録されている場合のエラーメッセージ(タグ使用可「"」を使用する場合は\でエスケープしてください)
$siteurlerrmsg = "同一のサイトURLが既に登録されています。<br>古い登録を修正・削除してください。";

#新規登録および削除・修正完了時のメッセージ(タグ使用可「"」を使用する場合は\でエスケープしてください)
$finishtxt = "<span class=\"txt_bold\">無事完了しました。ページに反映されるまでしばらくお待ちください。</span>";

######################################################
#排他的処理の設定

#連続した投稿を禁止するか(クッキーを利用) 0=禁止しない 1=禁止 2=禁止の上クッキーが無効の場合はJavaScriptで排除します
$chcookie = 1;

#連続投稿を禁止する時間(分) クッキーが有効の場合のみ
$nexttime = 60;

#クッキーの保存日数
$cookielimit = 10;

#クッキーにつけるタイトル
$cookietitle = "daw_linknavi_001";

#$chcookie=2の場合、ジャンプさせるページ
$nocookiejump = "nocookie.html";

#JavaScriptを無効にしているユーザーを排除するか 0=排除しない 1=排除する
$jsout = 0;

#$jsout=1の場合、ジャンプさせるページ
$nojsjump = "nojavascript.html";

#==========================================================================================
#$chcookie=1の場合、ブラウザ側でcookieが有効である必要があります
#そこで$chcookie=2ではcookieが無効の場合、JavaScriptで別ページに排除できるようにしました
#その場合でもブラウザのJavaScriptの設定が無効になっていれば機能しません
#さらに厳密に対処するために$jsout=1の設定でJSが無効のユーザーを別ページに排除します
#ただし、厳密にするほど排他的なサイトになるのでこの設定には注意が必要
#<noscript>などでJavaScriptの使用を前提としたページであることを明記するなどしてください
#==========================================================================================

######################################################
#バナーアップロードの設定

#保存ディレクトリ($cgidirディレクトリ内に置く場合は「$cgidir/bannersl」のように記述)
$banupdir = "bannersl";

#登録するバナーのサイズ(この大きさに拡大・縮小表示されます)
$banwidth = "88";
$banheight = "31";

#バナーの最大サイズ(kb)
$imgmaxsize = "10"; #*1024

#登録可能なバナーの拡張子(追加する場合、「,」で区切ってください)
@banimgch = ('gif','jpeg','jpg','png');

#登録がない場合、代用するバナー画像($imgdirで指定した画像フォルダに保存します)
$noimageimg = "noimage88x31.gif"; #代用するバナー画像

######################################################
#デザイン・レイアウトの設定

#表示順の初期設定
$typeselect = 1; #1=両方表示 2=ランキング順 3=新着順

#カテゴリーメニューの1つの段落に並べる数
$categorymenu_col = 8;

#バナーの代わりにサイトのサムネイル表示を有効にするか 0=無効(選択フォームなし) 1=有効(バナー優先) 2=有効(サムネイル優先)
$sitethum = 1;

#ナビゲーションバーにヘルプなどを追加したい場合、記述します(タグ使用可「"」を使用する場合は\でエスケープしてください)
$navisubtxt = "<span id=\"helparea\"><a href=\"\">HELP</a><p>■使い方ガイド<br>最新の情報に更新するには、右のReloadをクリックしてください。<br>その際、ラジオボタンをチェックすると、それに合わせた表\示形式が選択できます。<br>Site ViewもしくはBannerをクリックするとバナー表\示←→サイトイメージを切替えることができます。<br>サイト名にカーソ\ルを合わせると、そのサイトの紹介文が表\示されます。</p></span>";

#新規登録画面へのリンク表示(タグ使用可「"」を使用する場合は\でエスケープしてください)
$adminlink_entry = "<span class=\"txt_small\">新規登録</span>";

#修正・削除画面へのリンク表示(タグ使用可「"」を使用する場合は\でエスケープしてください)
$adminlink_delete = "<span class=\"txt_small\">修正・削除</span>";

#ナビゲーションバーの表示切替ラジオボタン名
$buttonname_fukugou = "複合"; #複合表示
$buttonname_ranking = "ランキング"; #ランキング表示
$buttonname_shinchaku = "新着"; #新着表示

#リロードボタンの前に付けるテキスト
$getnewtxt = "最新情報をGET! >>>";

#ナビゲーションバーのリロードボタン名
$reloadbuttonname = "Reload";

#ナビゲーションバーのバナー表示⇔サイト表示切替ボタン名
$sitechbuttonname = "Site View";
$bannerchbuttonname = "Banner";

#タイトルの表示名(タグ使用可「"」を使用する場合は\でエスケープしてください)
$toptitletxt_rank = "<span class=\"txt_red\">■</span>Top Ranking"; #ランキング順
$toptitletxt_new = "<span class=\"txt_red\">■</span>New Entry"; #新着順

#リンククリック回数順・逆アクセス回数順の表示名(タグ使用可「"」を使用する場合は\でエスケープしてください)
$toptitletxt_link = "(人気順)"; #リンククリック回数順

#メイン表示で1つの段落に並べる数
$column_dual = 6; #複合表示
$column_rank = 6; #ランキング表示
$column_new = 6; #新着表示

#1ページに表示する段落数(複合表示は上位１ページ分のみ)
$row_a = 10; #ランキングor新着単独
$row_b1 = 5; #複合ランキング
$row_b2 = 2; #複合新着

#複合表示の場合、ページ数に合わせて新着も過去に遡るか 0=常に上位で固定 1=順に送る
$new_feed = 1;

#バナーを表示するエリアの横幅(サイト名の表示幅にも影響。バナーサイズより大きくしてください)
$innersize = "155"; 

#表示する上限(両方空白はなし 重複の場合はいずれかの条件にマッチした時)
$maxdata = ""; #サイト数で指定
$maxpage = ""; #ページ数で指定

#カウントを表示するか 1=表示する
$counton = 1;

#新着にNEWマークを表示するか
$newtime = "24"; #この時間以内に登録された内容にNEWマークを付けます(空白はOFF)

#NEWマークのタグ(画像優先 両方空白は無し)
$newj = "new_43x12.gif"; #画像を指定($imgdirで指定した画像フォルダに保存します)
$newjw = "43"; #$newjの幅
$newjh = "12"; #$newjの高さ
$newm = "<span class=\"icon_new\">NEW!</span>"; #テキスト表示

#相互リンクの場合、表示するマークを設定(画像優先 両方空白は無し)
$sogoj = ""; #画像を指定($imgdirで指定した画像フォルダに保存します)
$sogojw = ""; #$sogojの幅
$sogojh = ""; #$sogojの高さ
$sogom = "<span class=\"icon_sogo\">相互</span>"; #テキスト表示

#管理人オススメの場合、表示するマークを設定(画像優先 両方空白は無し)
$osusumej = ""; #画像を指定($imgdirで指定した画像フォルダに保存します)
$osusumejw = ""; #$osusumejの幅
$osusumejh = ""; #$osusumejの高さ
$osusumem = "<span class=\"icon_osusume\">オススメ</span>"; #テキスト表示

#ページ送りの表示(タグ使用可「"」を使用する場合は\でエスケープしてください)
$prevtag = "PREV"; #次のページに移動
$nexttag = "NEXT"; #前のページに戻る

#曜日の表示名
@week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');

######################################################
#アウトカウントの設定

#アウトカウント(クリック数)を有効にするか 1=有効にする(無効にした場合、カウントアップされません)
$clickon = 1;
#※JavaScriptが有効である必要があり

#アウトカウントで同一リンクの連続カウントを防止するか(クッキー使用) 1=防止する(同じリンク先を続けてクリックした場合はカウントされません)
$choutcountcookie = 1;

#$choutcountcookie=1のとき、クッキーにつけるタイトル($cookietitleと重複しないように)
$cookieoutcounttitle = "daw_linknavi_102";

#アウトカウントのリダイレクトの方法
$redirect = 1; #1=Location 2=use CGI 3=ダイレクトに呼び出し
#==========================================================================================
#通常は1=Locationを利用してください。
#サーバーによってリダイレクトが制限されたものがあるようなのでダイレクトに戻る機能を用意しました
#==========================================================================================

#カウントのリセット日数 0=リセットしない
$resetdate = 0;

#アウトカウントアップするたびにデータベースをリフレッシュするか 1=する
$outcountrefresh = 0;

######################################################
#表示の優先順位の設定

#※管理人オススメはチェックすると設定したマークをつけるのみで順位には関係しません

#デフォルトの優先度(管理人が優先度を設定しない場合、この値が基準となります 数字が小さいほど優先)
$defpriority = 5; #半角数字

#ランキング項目の優先順位(1～3までの数字を優先度が高いほど小さくなるよう設定してください 同じ数字の重複はできません)
$rankcount = 1; #アウトカウント(クリック数)
$ranksogo = 2; #相互リンク
$rankpriority = 3; #優先度
#==========================================================================================
#初期状態の場合、アウトカウント数の多い順 > 相互リンクが有り > 優先度の数値の小さい順 という順位になります
#例えば優先度の数値を優先したければ$rankpriorityを1にして他の項目に2、3を割り振ります
#==========================================================================================

######################################################
#管理画面の設定

#削除・修正時にデータベースを自動でリフレッシュするか 1=有効
$admin_autorefresh = 0;

#管理画面に表示する説明文(タグ使用可「"」を使用する場合は\でエスケープしてください)
$admin_topmsg = "<p>削除もしくは修正するサイトのURLとパスワードを入力してください。<p><br>";

#登録内容を修正したとき、登録時間も更新するか 1=更新する(新着扱いになります)
$retime = 1;

######################################################
#データベースの設定

#DBMの種類 GDBMが使えない場合=0(レコードのサイズに制限有)
$dbm = 1;

#データベースのディレクトリ(データファイルは自動で作成)
$dbdir = "$cgidir/dbl";

#データベースのファイル名
$dbfile = "databasel";

#データベースのパス
$database = "$dbdir/$dbfile";

#データベースの区切り文字
$del = "<>";

#設定ここまで=========================================


######################################################
#制作者リンク(許可なく削除しないでください)
$productlink = "<div class=\"productlink\">-&nbsp;<a href=\"http://www1.ocn.ne.jp/~daworks/\" target=\"_blank\">DAW LINKNAVI</a>&nbsp;-</div>";
#=======================================================================
#著作権表示の削除については個別に対応させていただきます(別途費用がかかる場合があります)。
#以下のメールフォームから「DAW LINKNAVIの著作権削除依頼」といった形でお問い合わせください。
#http://www1.ocn.ne.jp/~daworks/mailform.html
#=======================================================================


######################################################
sub dbrefresh
	{
	my $chdatabase = $_[0]; #$database or $database\_back

	&lock;

	my $databasefile = "$dir1/$chdatabase";
	if (-e "$databasefile")
		{
		if ($dbm == 0)
			{
			tie(%dblogs, "SDBM_File", "$databasefile", O_CREAT | O_RDWR, 0644);
			}
		else
			{
			tie(%dblogs, "GDBM_File", "$databasefile", O_CREAT | O_RDWR, 0644);
			}

		my %templogs = %dblogs;
		untie(%dblogs);

		#元のDBファイルを削除
		#DBM形式で分岐
		if ($dbm == 0)
			{
			unlink ("$databasefile.dir","$databasefile.pag"); 
			}
		else #GDBM
			{	
			unlink $databasefile; 
			}
	
		if ($dbm == 0)
			{
			tie(%dblogs, "SDBM_File", "$databasefile", O_CREAT | O_RDWR, 0644);
			}
		else
			{
			tie(%dblogs, "GDBM_File", "$databasefile", O_CREAT | O_RDWR, 0644);
			}

		foreach $key (keys(%templogs))
			{
			$dblogs{$key} = $templogs{$key};
			}
		untie(%dblogs);
		&unlock;
		}
	}

######################################################
sub getontime
	{
	($nowtime) = $_[0]; #$today=time()
	my ($sec,$min,$hour,$day,$mon,$year,$wday) = gmtime($nowtime+$plusgmt); #現在時+9時間
	my $chdate = sprintf("%02d/%02d (%02d:%02d)", $mon+1,$day,$hour,$min); #日付を指定の形式に変換 01/22 (19:02)
	$chtime = sprintf("%04d/%02d/%02d (%s) %02d:%02d",$year+1900,$mon+1,$day,$week[$wday],$hour,$min); #2005/01/22 (Sat) 19:02
	$chyear = $year+1900;
	$chmon = $mon+1;
	$chday = $day;
	$chhour = $hour;
	$chmin = $min;
	}

######################################################
sub imageupload
	{
	open(IMGOUT,">$dir1/$banupdir/$upname") || die &output("画像のアップロードに失敗しました。もう一度やり直してください。");;
	binmode(IMGOUT);
	print IMGOUT $upfile;
	close(IMGOUT);
	}

######################################################
sub sogoch
	{
	my $html = $_[0];
	if ($html !~ /$tophtml/im)
		{
		$sogoerr ="相互リンク設置URL内に相互リンクが見つかりませんでした。<br>当サイトトップページのリンクを設置してから登録してください。";
		}
	}

######################################################
sub samedmainch
	{
	my $link = $_[0];

	#登録URLのドメインをチェック
	my $pos1 = index($siteurl,"/",7);
	if ($pos1 == -1)
		{
		$pos1 = length($siteurl);
		}
	my $domainpos1 = substr($siteurl,0,$pos1);

	#相互リンクのドメインをチェック
	my $pos2 = index($link,"/",7);
	if ($pos2 == -1)
		{
		$pos2 = length($link);
		}
	my $domainpos2 = substr($link,0,$pos2);

	if ($domainpos1 ne $domainpos2)
		{
		$damainerr = "登録サイトのドメイン = $domainpos1<br>対象のドメイン = $domainpos2";
		}
	else
		{
		$damainerr = "";	
		}
	}

######################################################
sub gethtml
	{
	#URLはチェック済み
	my $churl = $_[0];

	use LWP::UserAgent;
	my $ua = LWP::UserAgent->new;

	my $request = new HTTP::Request('GET', $churl);
	my $response = $ua->request($request);

	if ($response->is_success)
		{
		$content = $response->content;
		}
	else
		{
		$htmlch = 1;
		}
	}

######################################################
sub siteurlch
	{
	my $last = substr($siteurl,-1,1);
	my ($pos1,$pos2,$pos3);
	$chaff = 0;
	if ($last ne "/")
		{
		$pos1 = rindex($siteurl,".");
		if ($pos1 != -1)
			{
			my $str = substr($siteurl,$pos1+1);
			if ($str ne "html" && $str ne "htm" && $str ne "shtml" && $str ne "shtm" && $str ne "xhtml" && $str ne "php")
				{
				$chaff = 1;
				}
			}
		else
			{
			$chaff = 1;
			}
		}
	}

######################################################
sub lock
	{
	my $retry = "5"; #トライする回数
	my $i;

	my $timenow = time();
	my $lockdirx = "$dir2/$lockdir";

	if (-e $lockdirx)
		{
		my $checktime = (stat($lockdirx))[9];
		if (($timenow - $checktime) > 60)
			{
			rmdir($lockdirx);
			}
		}

	for ($i=1,$i<=$retry,$i++)
		{
		unless (mkdir($lockdirx,0755))
			{
			if ($i >= $retry)
				{
				&output("ロック処理ができません");
				sleep(1);
				}
			}
		else
			{
			$lockflag = 1; #ロック成功
			last;
			}
		}
	}

######################################################
sub unlock
	{
	my $lockdirx = "$dir2/$lockdir";

	rmdir($lockdirx);
	$lockflag = 0;
	}

######################################################
sub output
	{
	#パナーorサムネイル引数
	if ($sitethum == 2) #サムネイル優先
		{
		$imgtype = 2;
		}
	else #無効もしくはバナー優先
		{
		$imgtype = 1;
		}

	#カテゴリーメニュー
	my $categorymenu;
	if ($genreimgsw == 1) #画像
		{
		$categorymenu = "<div class=\"categorymenu\"><table class=\"categorymenu_table\"><tr><td class=\"categorymenu_td_left\"><a href=\"\$xdirx/$cgidir/$buildcgi?getid=$allid&viewtype=$typeselect&ranktype=$ranktype&imgtype=$imgtype&page=1\"><img src=\"$xdirx/$imgdir/$allgenreimg\" alt=\"$allgenre\" width=\"$genreimgw\" height=\"$genreimgh\"></a></td>";
		}
	else
		{
		$categorymenu = "<div class=\"categorymenu\"><table class=\"categorymenu_table\"><tr><td class=\"categorymenu_td_left\"><a href=\"\$xdirx/$cgidir/$buildcgi?getid=$allid&viewtype=$typeselect&ranktype=$ranktype&imgtype=$imgtype&page=1\">$allgenre</a></td>";
		}

	my $count = 1;
	my ($nocgich,$i);
	foreach (0 .. $#cidname)
		{
		if ($count >= $categorymenu_col)
			{
			$categorymenu .= "</tr><tr>";
			$count = 0;
			}

		$nocgich = "";
	    for ($i=0; $i<=@nojumplist; $i++)
			{
			if ($nojumplist[$i] eq $cidname[$_])
				{
				$nocgich = @nojumphtml[$i];
				last;
				}
			}

		#引数付で$buildcgiを呼び出す $xdirx = 相対パスは最後に置換え
		if ($count == 0) #一番左
			{
			if ($nocgich ne "")
				{
				if ($genreimgsw == 1) #画像
					{
					$categorymenu .= "<td class=\"categorymenu_td_left\"><a href=\"\$xdirx/$nocgich\"><img src=\"$xdirx/$imgdir/$cidimg[$_]\" alt=\"$cidname[$_]\" width=\"$genreimgw\" height=\"$genreimgh\"></a></td>";
					}
				else
					{
					$categorymenu .= "<td class=\"categorymenu_td_left\"><a href=\"\$xdirx/$nocgich\">$cidname[$_]</a></td>";
					}
				}
			else
				{
				if ($genreimgsw == 1) #画像
					{
					$categorymenu .= "<td class=\"categorymenu_td_left\"><a href=\"\$xdirx/$cgidir/$buildcgi?getid=$_&viewtype=$typeselect&ranktype=0&imgtype=$imgtype&page=1\"><img src=\"$xdirx/$imgdir/$cidimg[$_]\" alt=\"$cidname[$_]\" width=\"$genreimgw\" height=\"$genreimgh\"></a></td>";
					}
				else
					{
					$categorymenu .= "<td class=\"categorymenu_td_left\"><a href=\"\$xdirx/$cgidir/$buildcgi?getid=$_&viewtype=$typeselect&ranktype=0&imgtype=$imgtype&page=1\">$cidname[$_]</a></td>";
					}
				}
			}
		else
			{
			if ($nocgich ne "")
				{
				if ($genreimgsw == 1) #画像
					{
					$categorymenu .= "<td class=\"categorymenu_td\"><a href=\"\$xdirx/$nocgich\"><img src=\"$xdirx/$imgdir/$cidimg[$_]\" alt=\"$cidname[$_]\" width=\"$genreimgw\" height=\"$genreimgh\"></a></td>";
					}
				else
					{
					$categorymenu .= "<td class=\"categorymenu_td\"><a href=\"\$xdirx/$nocgich\">$cidname[$_]</a></td>";
					}
				}
			else
				{
				if ($genreimgsw == 1) #画像
					{
					$categorymenu .= "<td class=\"categorymenu_td\"><a href=\"\$xdirx/$cgidir/$buildcgi?getid=$_&viewtype=$typeselect&ranktype=0&imgtype=$imgtype&page=1\"><img src=\"$xdirx/$imgdir/$cidimg[$_]\" alt=\"$cidname[$_]\" width=\"$genreimgw\" height=\"$genreimgh\"></a></td>";
					}
				else
					{
					$categorymenu .= "<td class=\"categorymenu_td\"><a href=\"\$xdirx/$cgidir/$buildcgi?getid=$_&viewtype=$typeselect&ranktype=0&imgtype=$imgtype&page=1\">$cidname[$_]</a></td>";
					}
				}
			}
		$count++;		
		}

	#段落の余り部分を処理する
    while ($count%$categorymenu_col != 0)
		{
		$categorymenu .= "<td></td>";
		$count++;
		}

	#末尾の処理
	$categorymenu .= "</tr></table></div>";

	#ナビゲーションメニュー
	my ($checked1,$checked2,$checked3);
	if ($typeselect == 2) #ランキング
		{
		$checked1 = "";
		$checked2 = "checked ";
		$checked3 = "";
		}
	elsif ($typeselect == 3) #新着
		{
		$checked1 = "";
		$checked2 = "";
		$checked3 = "checked ";
		}
	else
		{
		$checked1 = "checked ";
		$checked2 = "";
		$checked3 = "";
		}

	#バナー・サムネイル切替フォーム
	my $imgchangeform;
	if ($sitethum > 0)
		{
		if ($imgtype == 1) #バナー表示
			{
			$imgchangeform = "<input name=\"exchangeact\" type=\"submit\" class=\"navigationmenu_submit\" value=\"$sitechbuttonname\">";	
			}
		else
			{
			$imgchangeform = "<input name=\"exchangeact\" type=\"submit\" class=\"navigationmenu_submit\" value=\"$bannerchbuttonname\">";	
			}
		}
	else #無効
		{
		$imgchangeform = "";
		}

	#表示切り替えフォーム
	my $viewtypeform = "<input name=\"viewtype\" type=\"radio\" value=\"1\" $checked1/>&nbsp;$buttonname_fukugou&nbsp;<input name=\"viewtype\" type=\"radio\" value=\"2\" $checked2/>&nbsp;$buttonname_ranking&nbsp;<input name=\"viewtype\" type=\"radio\" value=\"3\" $checked3/> $buttonname_shinchaku";

	#新規登録・修正削除
	my $adminlink = "<a href=\"\$xdirx/\$entrycgix\">$adminlink_entry</a> | <a href=\"\$xdirx/\$admincgix\">$adminlink_delete</a> | ";

#隠しフォーム
my $hiddenform =<<EOS;
<input type=hidden name=getid value=$allid>
<input type=hidden name=page value=1>
<input type=hidden name=imgtype value=$imgtype>
<input type=hidden name=ranktype value=$ranktype>
EOS

my $navimenu =<<EOS;
<div class="navigationmenu">
<form method="post" action=\$xdirx/\$buildcgix>
$navisubtxt
$hiddenform
$adminlink
<span class="navigationmenu_radiobutton">$viewtypeform</span>
$getnewtxt <input name="newwriteact" type="submit" class="navigationmenu_submit" value="$reloadbuttonname">
$imgchangeform
</form>
</div><!-- id="navigationmenu" -->
EOS

	#cookie無効の排除処理
	my $nocookiescript;
	if ($chcookie == 2)
		{
		$nocookiescript = "<script language=\"JavaScript\">if(navigator.cookieEnabled == false) { document.location = \"\$xdirx/$nocookiejump\"; } </script>";
		}
	else
		{
		$nocookiescript = "";
		}

	#JavaScript無効の排除処理
	my $nojs;
	if ($jsout == 1)
		{
		$nojs = "<noscript><META HTTP-EQUIV=Refresh CONTENT=\"0; URL=\$xdirx/$nojsjump\"></noscript>";
		}
	else
		{
		$nojs = "";
		}

my $inheader =<<EOS;
$nocookiescript
$nojs	
EOS

	#スキンHTMLを読み込んで出力=====================================
	&unlock if $lockflag; #ロック中ならロックを解除
	my $contents = $_[0];

	my $openskinhtml = "$dir1/$baseskinhtml";
	my $switch = 0;
	my ($headhtml,$mainhtml);

	open(IN,$openskinhtml);
	while(<IN>)
		{
		$_ =~ s/\r\n/\n/g; #s/ = 文字列の置き換え(改行コードの置き換え \r\n→\n)	
		if ($_ =~ /<\/head>/) #ヘッダー部分
			{
			$switch = 1;
			}
		#HTMLをブロック毎に格納していく
		$headhtml 	.= $_ if $switch == 0; #ヘッダ	
		$mainhtml 	.= $_ if $switch == 1;
		}
	close(IN);

	my $tempcontents = "$headhtml$inheader$mainhtml";

	foreach ($tempcontents)
		{
		$_ =~ s/\$categorymenu_position/$categorymenu/g;
		$_ =~ s/\$navimenu_position/$navimenu/g;
		$_ =~ s/\$contents_position/$contents/g;

		$_ =~ s/\$toppage/$tophtml/g;
		$_ =~ s/\$buildcgix/$cgidir\/$buildcgi/g;
		$_ =~ s/\$entrycgix/$cgidir\/$entrycgi/g;
		$_ =~ s/\$admincgix/$cgidir\/$admincgi/g;

		$_ =~ s/\$xdirx/$dir1/g;
		$_ =~ s/\$imgdirx/$imgdir/g;

		$_ =~ s/\$outcountcgix/$cgidir\/$outcountcgi/g;
		}

	print "Content-Type: text/html; charset=$enc{$enc}\n\n";
	print "$tempcontents";
	exit;
	}

######################################################
#フォームデータの取得(enctype="multipart/form-data"を使用しない)
sub getform
	{
	if ($ENV{'REQUEST_METHOD'} eq 'POST')
		{
  		read(STDIN, $alldata, $ENV{'CONTENT_LENGTH'});
		}
	else
		{
  		$alldata = $ENV{'QUERY_STRING'};
		}

	foreach $data (split(/&/, $alldata))
		{
  		($key, $value) = split(/=/, $data);
		$value =~ s/\+/ /g;
  		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
  		$value =~ s/\t//g;

		$value = Jcode -> new(\$value) -> $enc if($enc ne 'euc');
		$form{"$key"} = $value;
		}
	}

######################################################
#enctype="multipart/form-data"用
sub getform2
	{
	use CGI;

	my ($delimiter,$dish);
	$delimiter = <STDIN>;
	$delimiter =~s /\r\n//;
	$delimiter =~ s/\r|\n//g;
	$lastdelimiter = "$delimiter"."--";

	while(<STDIN>)
		{
		last if index($_,$lastdelimiter) != -1;

		#Content-Despositionヘッダーにfileuploadがある場合
		if ($_ =~ /fileupload/)
			{
			~s/\r\n//;								
			~s/"//g;
			($dish,$upname) = split(/filename=/, $_);
			$upname = $1 if $upname =~ /[\\|\/]([0-9a-zA-Z_\.]+)$/;	#正しいファイル名
			($first,$filext) = split(/\./, $upname);
			$filext =~tr/A-Z/a-z/;	#小文字へ変換
			$upfile = '';
			$contenttype = <STDIN>;	#Content-Typeヘッダー=次の行=
			$contenttype =~s /\r\n//; #改行を消す。
			($dish, $contenttype) = split(/\//,$contenttype); #後ろがアプリタイプ名
			$dish = <STDIN>; # 空行。次行は無視
			#バイナリデータ
			while(<STDIN>)
				{
				$endflag = 1 if (index($_,$lastdelimiter) != -1);
				last if index($_,$delimiter) != -1;
				$upfile .= $_; #バイナリーデータ
				}
			}
		else #通常データのとき
			{
			($dish, $key) = split(/name=/,$_);	
			$key =~s /\r\n//;
			$key =~s /"//g;
			$dish = <STDIN>; 	
			$value = '';
			while(<STDIN>)
				{
				$endflag = 1 if (index($_,$lastdelimiter) != -1);
				last if index($_,$delimiter) != -1;
				$value .= $_; 
				}
			# 改行等処理
			if ($brmsg && ($key eq "msgtxt"))
				{
				$value =~ s/(\r\n)$//g;
				$value =~ s/\r\n/<br>/g;
				$value =~ s/\r/<br>/g;
				$value =~ s/\n/<br>/g;
				}
			else 
				{
				$value =~ s/\r//g;
				$value =~ s/\n//g;
				}

#			$value = Jcode -> new(\$value) -> $enc if($enc ne 'euc');
			$form{$key} = $value;
			}
		if ($endflag)
			{
			last;	
			}
		}
	}

######################################################
sub debug
	{
	my $testlog = $_[0];
	
	print "Content-type: text/html\n";
	print "\n";
	print $testlog;
	exit;
	}

1;
