#!/usr/bin/perl
#daw_linknavi_n_outcount.cgi
#アウトカウント用Script

########################################################################
#スクリプト制作 DIGITAL@WORKS(http://www1.ocn.ne.jp/~daworks/)
#COPYRIGHT DIGITAL@WORKS ALL RESERVED
#許可なく複製・改変・再配布等を禁止します
########################################################################

#設定ファイルを呼び出し
require'./daw_linknavi_n_setting.cgi'; #このScriptから見た相対パス
require'./Jcode.pm';
use Fcntl;
if ($dbm == 0)
	{
	use SDBM_File;
	}
else
	{	
	use GDBM_File;
	}

#========================================================================
#JavaScriptが有効になっていればリンクをクリックすると
#このScriptにURLが送られる
#========================================================================

#クリック元URL取得
$url = $ENV{"QUERY_STRING"};
$referer = $ENV{'HTTP_REFERER'};

#引数がない場合は引数をつけて戻るページを設定する
my $repage;
if ($referer eq "$domain/$makehtml") #htmlから呼び出された場合はそのまま戻る
	{
	$repage = $referer;
	}
else
	{
	if ($referer ne "")
		{
		if (index($referer,"?getid=") == -1) #引数無し
			{
			#パナーorサムネイル
			my $imgtype;
			if ($sitethum == 2)
				{
				$imgtype = 2;
				}
			else
				{
				$imgtype = 1;	
				}
			$repage = $referer."?getid=$allid&viewtype=$typeselect&ranktype=0&imgtype=$imgtype&page=1";
			}
		else #引数有りの場合はそのままで
			{
			$repage = $referer;
			}
		}
	else #IEだとJavaScriptのlocation.hrefを使ったページ遷移だとリファラが無視される仕様のようなのでその対策
		{
 		$repage = "$domain/$makehtml";
		}
	}

if ($url ne "") #空の場合を排除
	{
	if (index($url,$domain) == -1) #サイト内からの移動を排除
		{
		#クッキーによる同一サイトへの連続カウント防止
		$nocountflag = 0;
		if ($choutcountcookie == 1)
			{
			&getcookielink;
			&checkcookielink;
			}

		#カウントアップ
		if ($nocountflag == 0)
			{
			&countup;
			if ($outcountrefresh == 1)
				{
				&dbrefresh("$database");
				}

			#URLをcookieに保存
			if ($choutcountcookie == 1)
				{
				&setcookielink;
				}
			}
		}
	}

#リダイレクト
if ($redirect == 2)
	{
	use CGI; #Locationが使えない場合
	$q = new CGI;
	print $q->redirect("$repage");
	}
elsif ($redirect == 3)
	{
	#それでもできない時の力業===============================================
	if (index($repage,"?getid=") == -1) #引数無し
		{
		$getid = $allid;
		$viewtype = $typeselect;
		$ranktype = 0;
		$imgtype = $imgtype;
		$page = 1;
		}
	else #引数有り
		{
		my ($pos1,$pos2,$pos3,$pos4);
		$pos1 = index($repage,"getid=");
		$pos2 = index($repage,"=",$pos1);
		$pos3 = index($repage,"&",$pos2);
		$pos4 = substr($repage,$pos2+1,$pos3-$pos2-1);
		$getid = $pos4;

		$pos1 = index($repage,"viewtype=");
		$pos2 = index($repage,"=",$pos1);
		$pos3 = index($repage,"&",$pos2);
		$pos4 = substr($repage,$pos2+1,$pos3-$pos2-1);
		$viewtype = $pos4;

		$ranktype = 0;

		$pos1 = index($repage,"imgtype=");
		$pos2 = index($repage,"=",$pos1);
		$pos3 = index($repage,"&",$pos2);
		$pos4 = substr($repage,$pos2+1,$pos3-$pos2-1);
		$imgtype = $pos4;

		$pos1 = index($repage,"page=");
		$pos2 = index($repage,"=",$pos1);
		$pos3 = index($repage,"&",$pos2);
		$pos4 = substr($repage,$pos2+1);
		$page = $pos4;
		}

	$outcountflag = 1; #$buildcgiでformを取得させないためのフラグ
	require"./$buildcgi"; #このScriptから見た相対パス
	}
else
	{
	print "Location: $repage\n\n";
	}

######################################################
sub countup
	{
	&lock;
	my $databasefile = "$dir1/$database";
	if ($dbm == 0)
		{
		tie(%dblogs, "SDBM_File", "$databasefile", O_CREAT | O_RDWR, 0644);
		}
	else
		{
		tie(%dblogs, "GDBM_File", "$databasefile", O_CREAT | O_RDWR, 0644);
		}

	#データベースを検索して対象サイトを取得
	while(($name,$key) = each(%dblogs))
		{
		@data = split(/$del/,$key);
		if ($url eq $data[4])
			{
			my $upcount = $data[10] + 1;
			$dblogs{$name} = "$data[0]$del$data[1]$del$data[2]$del$data[3]$del$data[4]$del$data[5]$del$data[6]$del$data[7]$del$data[8]$del$data[9]$del$upcount$del$data[11]$del$data[12]$del$data[13]$del$data[14]$del$data[15]$del$data[16]$del$data[17]$del$data[18]$del$data[19]$del";
			last;
			}
		}

	untie(%dblogs);
	&unlock;
	}

######################################################
#クッキーに書き込み
sub setcookielink
	{
	#有効期限は設定しない=ブラウザを閉じるまで
	print "Set-Cookie: $cookieoutcounttitle=$url\n";
	}

######################################################
sub checkcookielink
	{
	if ($lsiteurl && (index($url,$lsiteurl) != -1))
		{
		$nocountflag = 1;
		}
	}

######################################################
sub getcookielink
	{
	my ($getcookies,@pairs,$name,$value,%DUMMY);		

	$getcookies = $ENV{"HTTP_COOKIE"};
	@pairs = split(/;/, $getcookies);

	foreach (@pairs)
		{
		($name, $value) = split(/=/);
		$value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
		$name =~ s/\s//g;
		$DUMMY{$name} = $value;
		}		

	($lsiteurl) = split(/,/, $DUMMY{"$cookieoutcounttitle"});
	}
